// -------------------------------------------------------------------------------
// 
// 		cwCu		t@CANZXvOwb_t@C
// 
// 				Ver 3.14f
// 
// -------------------------------------------------------------------------------

#ifndef __DXFILE_H__
#define __DXFILE_H__

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"
#include "DxLib.h"
#include "DxStatic.h"
#include "DxHandle.h"


// }N` --------------------------------------------------------------------

// CuŎgpt@CANZXp֐
#define FSYNC( handle )                             {while( FIDLECHK( handle ) == FALSE ) Thread_Sleep(0);}
#define FOPEN( path )								StreamOpen( (path), FALSE, TRUE, FALSE )
#define FOPENT( path )								StreamOpenT( (path), FALSE, TRUE, FALSE )
#define FOPEN_CACHE( path )							StreamOpen( (path),  TRUE, TRUE, FALSE )
#define FOPEN_ASYNC( path )							StreamOpen( (path), FALSE, TRUE,  TRUE )
#define FCLOSE( handle )							StreamClose( (DWORD_PTR)(handle) )
#define FREAD( buf, length, num, handle )			StreamRead( (void *)(buf), (size_t)(length), (size_t)(num), (DWORD_PTR)(handle) )
#define FSEEK( handle, pos, mode )					StreamSeek( (DWORD_PTR)(handle), (LONGLONG)(pos), (int)(mode) )
#define FTELL( handle )								StreamTell( (DWORD_PTR)(handle) )
#define FEOF( handle )								StreamEof( (DWORD_PTR)(handle) )
#define FIDLECHK( handle )							StreamIdleCheck( (DWORD_PTR)(handle) )
#define FSETDIR( path )								StreamChDir( (path) )
#define FGETDIR( buffer )							StreamGetDir( (buffer) )
#define FFINDFIRST( path, buffer )					StreamFindFirst( (path), (buffer) )
#define FFINDNEXT( handle, buffer )					StreamFindNext( (DWORD_PTR)(handle), (buffer) )
#define FFINDCLOSE( handle )						StreamFindClose( (DWORD_PTR)(handle) )

// t@CANZXpXbhւ̎w
#define FILEACCESSTHREAD_FUNCTION_OPEN		(0)				// t@CJ
#define FILEACCESSTHREAD_FUNCTION_CLOSE		(1)				// t@C
#define FILEACCESSTHREAD_FUNCTION_READ		(2)				// t@Cǂݍ
#define FILEACCESSTHREAD_FUNCTION_SEEK		(3)				// t@C|C^ړ
#define FILEACCESSTHREAD_FUNCTION_EXIT		(4)				// I

#define FILEACCESSTHREAD_DEFAULT_CACHESIZE	(128 * 1024)	// ftHg̃LbVTCY

// nh^Cv
#define FILEHANDLETYPE_NORMAL				(0)				// ʏ̃t@Cnh
#define FILEHANDLETYPE_FULLYLOAD			(1)				// t@C̓eɓǂݍ񂾏p̃nh

// t@CpX̍ő咷
#define FILEPATH_MAX						(512 * 3)


// ˑ`wb_t@C̃CN[h --------------------------------------

#ifdef __WINDOWS__
#include "Windows/DxFileWin.h"
#endif // __WINDOWS__

#ifdef __PSVITA
#include "PSVita/DxFilePSVita.h"
#endif // __PSVITA

#ifdef __PS4
#include "PS4/DxFilePS4.h"
#endif // __PS4


#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// \̒` --------------------------------------------------------------------

// t@CANZXnh
struct FILEACCESSINFO
{
	HANDLEINFO				HandleInfo ;						// nhʃf[^
	int						HandleType ;						// nh^Cv( FILEHANDLETYPE_NORMAL Ȃ )

	// FILEHANDLETYPE_NORMAL ł̂ݎgp
	DWORD_PTR				FilePointer ;						// t@C|C^

	// FILEHANDLETYPE_FULLYLOAD ł̂ݎgp
	void					*FileImage ;						// ǂݍ񂾃t@Ci[̈ւ̃|C^
	LONGLONG				FileSize ;							// t@CTCY
} ;

// t@CANZXp\
struct FILEACCESS
{
	int						EofFlag ;							// I[`FbNtO
	ULONGLONG				Position ;							// ANZXʒu
	ULONGLONG				Size ;								// TCY
	int						UseASyncReadFlag ;					// 񓯊ǂݍ݂sǂ

	FILEACCESS_PF			PF ;								// ˑ
} ;

// t@Cp\
struct FINDINFO
{
	FINDINFO_PF				PF ;								// ˑ
} ;

// ϐ錾 --------------------------------------------------------------

// ftHgXg[t@NV
extern STREAMDATASHREDTYPE2W StreamFunctionW ;

// ֐vg^Cv錾-----------------------------------------------------------

// t@CANZX̏EI֐
extern	int			InitializeFile( void ) ;														// t@CANZX̏
extern	int			TerminateFile( void ) ;															// t@CANZX̌n

// ǂݍݐpt@CANZX֐
extern	DWORD_PTR	ReadOnlyFileAccessOpen( const wchar_t *Path, int UseCacheFlag, int BlockReadFlag, int UseASyncReadFlag  ) ;
extern	int			ReadOnlyFileAccessClose( DWORD_PTR Handle ) ;
extern	LONGLONG	ReadOnlyFileAccessTell( DWORD_PTR Handle ) ;
extern	int			ReadOnlyFileAccessSeek( DWORD_PTR Handle, LONGLONG SeekPoint, int SeekType ) ;
extern	size_t		ReadOnlyFileAccessRead( void *Buffer, size_t BlockSize, size_t DataNum, DWORD_PTR Handle ) ;
extern	int			ReadOnlyFileAccessEof( DWORD_PTR Handle ) ;
extern	int			ReadOnlyFileAccessIdleCheck( DWORD_PTR Handle ) ;
extern	int			ReadOnlyFileAccessChDir( const wchar_t *Path ) ;
extern	int			ReadOnlyFileAccessGetDir( wchar_t *Buffer ) ;
extern	DWORD_PTR	ReadOnlyFileAccessFindFirst( const wchar_t *FilePath, FILEINFOW *Buffer ) ;				// ߂l: -1=G[  -1ȊO=FindHandle
extern	int			ReadOnlyFileAccessFindNext( DWORD_PTR FindHandle, FILEINFOW *Buffer ) ;					// ߂l: -1=G[  0=
extern	int			ReadOnlyFileAccessFindClose( DWORD_PTR FindHandle ) ;									// ߂l: -1=G[  0=

// ݐpt@CANZX֐
extern	int			WriteOnlyFileAccessDelete( const wchar_t *Path ) ;
extern	DWORD_PTR	WriteOnlyFileAccessOpen( const wchar_t *Path ) ;
extern	DWORD_PTR	WriteOnlyFileAccessOpenWCHAR( const char *Path ) ; // Visual C++ 6.0 pɈ char ^ɂ̂
extern	int			WriteOnlyFileAccessClose( DWORD_PTR Handle ) ;
extern	int			WriteOnlyFileAccessSeek( DWORD_PTR Handle, LONGLONG SeekPoint, int SeekType ) ;
extern	int			WriteOnlyFileAccessWrite( DWORD_PTR Handle, void *Buffer, size_t WriteSize, size_t *GetWriteSize = NULL ) ;
extern	int			WriteOnlyFileAccessPrintf( DWORD_PTR Handle, const char *FormatString, ... ) ;

// Xg[f[^ANZX֐
extern	DWORD_PTR	StreamOpen(  const wchar_t *Path, int UseCacheFlag, int BlockFlag, int UseASyncReadFlag ) ;
extern	DWORD_PTR	StreamOpenT( const TCHAR   *Path, int UseCacheFlag, int BlockFlag, int UseASyncReadFlag ) ;
extern	int			StreamClose( DWORD_PTR Handle ) ;
extern	LONGLONG	StreamTell( DWORD_PTR Handle ) ;
extern	int			StreamSeek( DWORD_PTR Handle, LONGLONG SeekPoint, int SeekType ) ;
extern	size_t		StreamRead( void *Buffer, size_t BlockSize, size_t DataNum, DWORD_PTR Handle ) ;
extern	int			StreamEof( DWORD_PTR Handle ) ;
extern	int			StreamIdleCheck( DWORD_PTR Handle ) ;
extern	int			StreamChDir(  const wchar_t *Path ) ;
extern	int			StreamChDirT( const TCHAR   *Path ) ;
extern	int			StreamGetDir(  wchar_t *Buffer ) ;
extern	int			StreamGetDirT( TCHAR   *Buffer ) ;
extern	DWORD_PTR	StreamFindFirst(  const wchar_t *FilePath, FILEINFOW *Buffer ) ;		// ߂l: -1=G[  -1ȊO=FindHandle
extern	DWORD_PTR	StreamFindFirstT( const TCHAR   *FilePath, FILEINFO  *Buffer ) ;		// ߂l: -1=G[  -1ȊO=FindHandle
extern	int			StreamFindNext(  DWORD_PTR FindHandle, FILEINFOW *Buffer ) ;			// ߂l: -1=G[  0=
extern	int			StreamFindNextT( DWORD_PTR FindHandle, FILEINFO  *Buffer ) ;			// ߂l: -1=G[  0=
extern	int			StreamFindClose( DWORD_PTR FindHandle ) ;								// ߂l: -1=G[  0=
extern	const STREAMDATASHREDTYPE2W *StreamGetStruct( void ) ;

// t@C wchar_t ł TCHAR ł̃f[^ϊ֐
extern	int			ConvFileIntoToFileInfoW( FILEINFO  *Src, FILEINFOW *Dest ) ;
extern	int			ConvFileIntoWToFileInfo( FILEINFOW *Src, FILEINFO  *Dest ) ;

// Xg[f[^ANZXp֐\̊֌W
extern	STREAMDATASHRED *GetFileStreamDataShredStruct( void ) ;								// Xg[f[^ǂ݂ݐp֐|C^\̂̃t@Cp\̂𓾂
extern	STREAMDATASHRED *GetMemStreamDataShredStruct( void ) ;								// Xg[f[^ǂ݂ݐp֐|C^\̂ؗp\̂𓾂




// t@Cnh֐
extern	int			FileRead_open_UseGParam( const wchar_t *FilePath, int ASync, int ASyncLoadFlag = FALSE ) ;				// t@CJ
extern	int			FileRead_seek_UseGParam( int FileHandle, LONGLONG Offset, int Origin, int ASyncLoadFlag = FALSE ) ;		// t@C|C^̈ʒuύX
extern	int			FileRead_read_UseGParam( int FileHandle, void *Buffer, int ReadSize, int ASyncLoadFlag = FALSE ) ;		// t@Cf[^ǂݍ
extern	int			FileRead_fullyLoad_UseGParam( const wchar_t *FilePath, int ASyncLoadFlag = FALSE ) ;					// w̃t@C̓eSăɓǂݍ݁Ȁ̃ANZXɕKvȃnhԂ( ߂l  -1:G[  -1ȊO:nh )AgInh FileRead_fullyLoad_delete ō폜Kv܂
extern	int			FileRead_scanf_base(        int       FileHandle, const void  *Format,        va_list Param ) ;	// t@C珑ꂽf[^ǂݏo
extern	int			FileRead_scanf_baseCHAR(    DWORD_PTR FileHandle, const char  *Format,        va_list Param ) ;	// t@C珑ꂽf[^ǂݏo
extern	int			FileRead_scanf_baseUTF16LE( DWORD_PTR FileHandle, const WORD  *FormatUTF16LE, va_list Param ) ;	// t@C珑ꂽf[^ǂݏo



// ɒuꂽf[^t@C̃f[^ɗႦĂ߂̊֐
extern	void*		MemStreamOpen( const void *DataBuffer, unsigned int DataSize ) ;
extern	int			MemStreamClose( void *StreamDataPoint ) ;



// t@CpX֌W

// tpXł͂ȂpXtpXɕϊ
// ( CurrentDir ̓tpXłKv(Ɂw\xĂĂǂ) )
// ( CurrentDir  NULL ̏ꍇ݂͌̃JgfBNggp )
//extern int			ConvertFullPath_( const char *Src, char *Dest, const char *CurrentDir = NULL ) ; 
extern int			ConvertFullPathW_( const wchar_t *Src, wchar_t *Dest, const wchar_t *CurrentDir = NULL ) ; 
extern int			ConvertFullPathT_( const TCHAR *Src, TCHAR *Dest, const TCHAR *CurrentDir = NULL ) ; 

// w̃t@CpXw̃tH_pX瑊΃ANZX邽߂̑΃pX쐬
// ( FilePath  StartFolderPath tpXł͂Ȃꍇ͊֐ŃtpX܂ )
// StartFolderPath ̖[ / or \ Ă肠܂
//extern int			CreateRelativePath_( const char *FilePath, const char *StartFolderPath, char *Dest ) ;
extern int			CreateRelativePathW_( const wchar_t *FilePath, const wchar_t *StartFolderPath, wchar_t *Dest ) ;
extern int			CreateRelativePathT_( const TCHAR   *FilePath, const TCHAR   *StartFolderPath, TCHAR   *Dest ) ;

// ̃pX񂩂FXȏ擾
// ( CurrentDir ̓tpXłKv(Ɂw\xĂĂǂ) )
// ( CurrentDir  0 ̏ꍇ͎ۂ̃JgfBNggp )
extern int			AnalyseFilePathW_( const wchar_t *Src, // DirPath ̏I[ɂ \ ͕tȂ
						wchar_t *FullPath, wchar_t *DirPath, wchar_t *FileName, wchar_t *Name, wchar_t *ExeName, const wchar_t *CurrentDir = 0 );
extern int			AnalyseFilePathT_( const TCHAR   *Src, // DirPath ̏I[ɂ \ ͕tȂ
						TCHAR   *FullPath, TCHAR   *DirPath, TCHAR   *FileName, TCHAR   *Name, TCHAR   *ExeName, const TCHAR   *CurrentDir = 0 );

// t@CꏏɂȂĂƕĂpXt@CƃfBNgpX𕪊
// tpXłKv͖At@Cłǂ
// DirPath ̏I[  }[N͕tȂ
//extern int		AnalysisFileNameAndDirPath_( const char *Src, char *FileName = 0, char *DirPath = 0 ) ;
extern int			AnalysisFileNameAndDirPathW_( const wchar_t *Src, wchar_t *FileName = 0, wchar_t *DirPath = 0 ) ;
extern int			AnalysisFileNameAndDirPathT_( const TCHAR   *Src, TCHAR   *FileName = 0, TCHAR   *DirPath = 0 ) ;

// t@CpXt@CƊgq擾
//extern int		AnalysisFileNameAndExeName_( const char *Src, char *Name = 0, char *ExeName = 0 ) ;
extern int			AnalysisFileNameAndExeNameW_( const wchar_t *Src, wchar_t *Name = 0, wchar_t *ExeName = 0 ) ;
extern int			AnalysisFileNameAndExeNameT_( const TCHAR   *Src, TCHAR   *Name = 0, TCHAR   *ExeName = 0 ) ;

// t@CpX̊gqς𓾂
//extern int		GetChangeExeNamePath_( const char *Src, char *Dest, const char *ExeName ) ;

extern void			SetEnMarkT_( TCHAR   *PathBuf ) ;				// Ɂw\xĂȂꍇ͕t
extern void			SetEnMarkW_( wchar_t *PathBuf ) ;				// Ɂw\xĂȂꍇ͕t

extern void			ChangeEnMarkToSlashT_( TCHAR   *PathBuf ) ;		// pX񒆂́w\xw/xɕϊ
extern void			ChangeEnMarkToSlashW_( wchar_t *PathBuf ) ;		// pX񒆂́w\xw/xɕϊ

// nꂽtpXƂĈAhCu( :\ or :/ ̑O܂ )
// ̓lbg[NtH_( \ or / ̑O܂ )擾
// lbg[NtH_ꍇ͍ŏ \\ ܂߂
// ߂l͎擾̒( lbg[NtH_̏ꍇ \\ ʂɊ܂܂܂ )
// Src ̓tpXłKv܂A΃pXł͐ɓ삵܂
//extern int		AnalysisDriveName_( const char *Src, char *Dest ) ;
extern int			AnalysisDriveNameW_( const wchar_t *Src, wchar_t *Dest ) ;

// nꂽtH_pXƂĈAtH_( \ or / ̑O܂ )擾܂
// n񂪃tpXŁAŏɃhCuĂ琳Ȍʂ܂
// ../ ̉ʃtH_ɍ~镶񂪂ꍇ .. o͂܂
// ߂l͎擾̒ł
//extern int		AnalysisDirectoryName_( const char *Src, char *Dest ) ;
extern int			AnalysisDirectoryNameW_( const wchar_t *Src, wchar_t *Dest ) ;





// ˑp֐

// t@CANZX̏EI֐
extern	int			InitializeFile_PF( void ) ;														// t@CANZX̏֐̊ˑ̏s֐
extern	int			TerminateFile_PF( void ) ;														// t@CANZX̌n֐̊ˑ̏s֐

// t@CANZX֐
extern	int			ReadOnlyFileAccessOpen_PF(		FILEACCESS *FileAccess, const wchar_t *Path, int UseCacheFlag, int BlockReadFlag ) ;
extern	int			ReadOnlyFileAccessClose_PF(		FILEACCESS *FileAccess ) ;
extern	LONGLONG	ReadOnlyFileAccessTell_PF(		FILEACCESS *FileAccess ) ;
extern	int			ReadOnlyFileAccessSeek_PF(		FILEACCESS *FileAccess, LONGLONG SeekPoint ) ;
extern	size_t		ReadOnlyFileAccessRead_PF(		void *Buffer, size_t BlockSize, size_t DataNum, FILEACCESS *FileAccess ) ;
extern	int			ReadOnlyFileAccessIdleCheck_PF(	FILEACCESS *FileAccess ) ;
extern	int			ReadOnlyFileAccessChDir_PF(		const wchar_t *Path ) ;
extern	int			ReadOnlyFileAccessGetDir_PF(	wchar_t *Buffer ) ;
extern	int			ReadOnlyFileAccessFindFirst_PF(	FINDINFO *FindInfo, const wchar_t *FilePath, FILEINFOW *Buffer ) ;
extern	int			ReadOnlyFileAccessFindNext_PF(	FINDINFO *FindInfo, FILEINFOW *Buffer ) ;
extern	int			ReadOnlyFileAccessFindClose_PF(	FINDINFO *FindInfo ) ;

// ݐpt@CANZX֐
extern	int			WriteOnlyFileAccessDelete_PF( const wchar_t *Path ) ;
extern	DWORD_PTR	WriteOnlyFileAccessOpen_PF(  const wchar_t *Path ) ;
extern	int			WriteOnlyFileAccessClose_PF( DWORD_PTR Handle ) ;
extern	int			WriteOnlyFileAccessSeek_PF(  DWORD_PTR Handle, LONGLONG SeekPoint, int SeekType ) ;
extern	int			WriteOnlyFileAccessWrite_PF( DWORD_PTR Handle, void *Buffer, size_t WriteSize, size_t *GetWriteSize = NULL ) ;


#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // __DXFILE_H__

